/*
 * $Id: TurretPool.as,v 1.1.1.1 2007/04/01 08:25:41 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2 {
  import flash.display.BitmapData;
  import abagames.util.Actor;
  import abagames.util.ActorPool;
  import abagames.util.Vector;

  /**
   * Turret pool.
   */
  public class TurretPool extends ActorPool {
    private var buffer:BitmapData;
    private var player:Player;
    private var field:Field;
    private var bullets:BulletPool;
    private var particles:ParticlePool;

    public function TurretPool(n:int, buffer:BitmapData, player:Player, field:Field,
                             bullets:BulletPool, particles:ParticlePool) {
      this.buffer = buffer;
      this.player = player;
      this.field = field;
      this.bullets = bullets;
      this.particles = particles;
      super(n);
    }

    protected override function createActor():Actor {
      return new Turret(buffer, player, field, bullets, particles);
    }

    public function removeAll():void {
      while (actorNum > 0) {
        var t:Turret = Turret(actors[0]);
        t.destroy();
      }
    }

    public function removeTainted():int {
      var c:int = 0;
      for (var i:int = 0; i < actorNum; i++) {
        var t:Turret = Turret(actors[i]);
        if (t.tainted) {
          t.destroy();
          i--;
          c++;
        }
      }
      return c;
    }
  }
}
