/*
 * $Id: Bar.as,v 1.1 2007/04/04 13:08:57 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2.barrage {
  import abagames.util.Vector;
  import abagames.la2.BulletPool;
  import abagames.la2.ParticlePool;
  import abagames.la2.Player;

  /**
   * Bar shaped bullets.
   */
  public class Bar extends Barrage {
    private const FIRE_SPEED:Number = 1;
    private const FIRE_INTERVAL:Number = 60;

    public function Bar(bullets:BulletPool, particles:ParticlePool, player:Player) {
      super(bullets, particles, player);
    }

    public override function update(pos:Vector, state:BarrageState):void {
      var rapidNum:int = 2 + state.rank * 4;
      var c:int = state.cnt;
      if (!state.update(FIRE_INTERVAL * state.interval / (1 + state.rank), rapidNum * 7))
        return;
      if (c % 7 != 0)
        return;
      if (!state.fires) {
        state.fires = true;
        state.fireDeg = Math.atan2(player.pos.x - pos.x, player.pos.y - pos.y);
        state.firePos.x = pos.x;
        state.firePos.y = pos.y;
      }
      var fireSpeed:Number = FIRE_SPEED * state.speed * (1 + state.rank);
      fire(state.firePos, state.fireDeg, fireSpeed, state.tainted);
    }
  }
}
