/*
 * $Id: BarrageState.as,v 1.1 2007/04/04 13:08:57 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2.barrage {
  import abagames.util.Vector;

  /**
   * State of a barrage.
   */
  public class BarrageState {
    public var tainted:Boolean;
    public var onCell:Boolean;
    public var fireCnt:int;
    public var fireDeg:Number;
    public var fireDegVel:Number;
    public var firePos:Vector;
    public var fires:Boolean;
    private var _cnt:int;
    private var _rank:Number;
    private var _interval:Number;
    private var _speed:Number;
    private var isFirst:Boolean;

    public function BarrageState() {
      firePos = new Vector;
    }

    public function init(interval:Number, speed:Number):void {
      tainted = false;
      onCell = true;
      fireCnt = 0;
      fireDeg = 0;
      fireDegVel = 1;
      fires = false;
      _cnt = 0;
      _rank = 0;
      _interval = interval;
      _speed = speed;
      isFirst = true;
    }

    public function update(intervalCnt:int, fireCnt:int = 1):Boolean {
      if (tainted)
        _rank += (1.0 - _rank) * 0.003;
      _cnt--;
      if (_cnt >= fireCnt)
        return false;
      if (_cnt <= 0) {
        _cnt = intervalCnt;
        if (!onCell)
          _cnt *= 2;
        fires = false;
      }
      if (isFirst) {
        isFirst = false;
        return false;
      }
      return true;
    }

    public function get cnt():int {
      return _cnt;
    }

    public function get rank():Number {
      return _rank;
    }

    public function get interval():Number {
      return _interval;
    }

    public function get speed():Number {
      return _speed;
    }
  }
}
