/*
 * $Id: Nway.as,v 1.1 2007/04/04 13:08:57 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2.barrage {
  import abagames.util.Vector;
  import abagames.la2.BulletPool;
  import abagames.la2.ParticlePool;
  import abagames.la2.Player;

  /**
   * N-way.
   */
  public class Nway extends Barrage {
    private const FIRE_SPEED:Number = 1;
    private const FIRE_INTERVAL:Number = 100;

    public function Nway(bullets:BulletPool, particles:ParticlePool, player:Player) {
      super(bullets, particles, player);
    }

    public override function update(pos:Vector, state:BarrageState):void {
      if (!state.update(FIRE_INTERVAL * state.interval / (1 + state.rank)))
        return;
      var fireSpeed:Number = FIRE_SPEED * state.speed * (1 + state.rank);
      var nway:int = 3 + int(state.rank * 5) * 2;
      var deg:Number = Math.atan2(player.pos.x - pos.x, player.pos.y - pos.y);
      var id:Number = Math.PI / 3 * 2 / (nway - 1);
      deg -= Math.PI / 3;
      for (var i:int = 0; i < nway; i++) {
        fire(pos, deg, fireSpeed, state.tainted);
        deg += id;
      }
    }
  }
}
