/*
 * $Id: Shotgun.as,v 1.1 2007/04/04 13:08:57 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2.barrage {
  import abagames.util.Vector;
  import abagames.la2.BulletPool;
  import abagames.la2.ParticlePool;
  import abagames.la2.Player;

  /**
   * Shotgun.
   */
  public class Shotgun extends Barrage {
    private const FIRE_SPEED:Number = 1;
    private const FIRE_INTERVAL:Number = 80;

    public function Shotgun(bullets:BulletPool, particles:ParticlePool, player:Player) {
      super(bullets, particles, player);
    }

    public override function update(pos:Vector, state:BarrageState):void {
      if (!state.update(FIRE_INTERVAL * state.interval / (1 + state.rank)))
        return;
      var fireSpeed:Number = FIRE_SPEED * state.speed * (1 + state.rank);
      var num:int = 2 + int(state.rank * 10);
      var deg:Number = Math.atan2(player.pos.x - pos.x, player.pos.y - pos.y);
      for (var i:int = 0; i < num; i++)
        fire(pos, deg + (Math.random() - 0.5) * 0.3, fireSpeed * (1 + (Math.random() - 0.5) * 0.3), state.tainted);
    }
  }
}
