/*
 * $Id: Spray.as,v 1.1 2007/04/04 13:08:57 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2.barrage {
  import abagames.util.Vector;
  import abagames.la2.BulletPool;
  import abagames.la2.ParticlePool;
  import abagames.la2.Player;

  /**
   * Spray fire.
   */
  public class Spray extends Barrage {
    private const FIRE_SPEED:Number = 1;
    private const FIRE_INTERVAL:Number = 30;

    public function Spray(bullets:BulletPool, particles:ParticlePool, player:Player) {
      super(bullets, particles, player);
    }

    public override function update(pos:Vector, state:BarrageState):void {
      if (!state.update(FIRE_INTERVAL * state.interval * (1 - state.rank * 0.9)))
        return;
      var fireSpeed:Number = FIRE_SPEED * state.speed * (1 + state.rank);
      var deg:Number = Math.atan2(player.pos.x - pos.x, player.pos.y - pos.y);
      var nway:int = 3 + int(state.rank * 5) * 2;
      var id:Number = Math.PI / (nway + 1);
      state.fireCnt += state.fireDegVel;
      if (state.fireCnt >= (nway + 1) / 2 || state.fireCnt <= -(nway + 1) / 2 ) {
        state.fireDegVel *= -1;
        state.fireCnt += state.fireDegVel * 2;
      }
      fire(pos, deg + id * state.fireCnt, fireSpeed, state.tainted);
    }
  }
}
