/*
 * $Id: Whip.as,v 1.1 2007/04/04 13:08:58 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.la2.barrage {
  import abagames.util.Vector;
  import abagames.la2.BulletPool;
  import abagames.la2.ParticlePool;
  import abagames.la2.Player;

  /**
   * Whip shaped bullets.
   */
  public class Whip extends Barrage {
    private const FIRE_SPEED:Number = 1;
    private const FIRE_INTERVAL:Number = 80;

    public function Whip(bullets:BulletPool, particles:ParticlePool, player:Player) {
      super(bullets, particles, player);
    }

    public override function update(pos:Vector, state:BarrageState):void {
      var rapidNum:int = 2 + state.rank * 5;
      var c:int = state.cnt;
      if (!state.update(FIRE_INTERVAL * state.interval / (1 + state.rank), rapidNum * 3))
        return;
      if (c % 3 != 0)
        return;
      var fireSpeed:Number = FIRE_SPEED * state.speed * (1 + state.rank);
      fireSpeed *= (1 + (rapidNum - int(c / 3)) * 0.2);
      var deg:Number = Math.atan2(player.pos.x - pos.x, player.pos.y - pos.y);
      fire(pos, deg, fireSpeed, state.tainted);
    }
  }
}
